  

#include	<pic18.h>



#define tmr2_period 	64
#define	segments	PORTB
#define common_1 	RC4
#define common_2	RC5
#define common_3 	RC6	
#define common_4  	RC7
#define common_5 	RD3
#define common_6 	RD2
#define	motor		RA0
#define	skare		RA1
#define	start_tipka	 RE0
#define	stop_tipka	 RE1
#define	sensor_skara_gore 	RE2
#define	sensor_skara_dolje	RC1
#define	sensor_lima 	RC2
#define	sensor_preostali_lim 	RC3
#define	rele2		RA2
#define	rele3		RA3
#define start      1
#define stop       0




//------- Globalne Variable, Buffers etc ----------
unsigned char Buffer1[4], Buffer2[2];

unsigned char KeyPressed,Key_real,setup,set,timer_skare;
unsigned char setup1,taster_otpusten,taster_pritisnut,taster_brojac,step;
unsigned char novi_ciklus;
unsigned char tmr3_brojac,portd,start_stroja,stroj_radi,izbacivanje_lima,rina_izradjena;
signed char L,X,broj_komada;			
int brojac1,brojac2;
float brojac_float,koeficijent;
signed char deshilj,hilj,sto,des,jed,des_kom,jed_kom;
unsigned int _dcnt,brojac,brojac4;
unsigned char  	data_TMR0L,
				data_TMR0H,
				data_TMR1L,
				data_TMR1H;

unsigned char a_prva_faza,b_prva_faza,jedan_ciklus; 

unsigned int navoja,start_timer,stop_timer,zadana_duzina,izmjerena_duzina;

bit		channel_led_5,
		channel_led_4,		// contains channel select LED state for channel LED 1-3
		channel_led_3,
		channel_led_2,
		channel_led_1;
		



unsigned char	display_segment_[6],
				display_segment_komada[3],
				mux_common,
				nova_vrednost,
				stara_vrednost,
				debounce_tastatura,
				debounce_time_tastatura,
				temp1,
				temp2;
				
unsigned char const	segment_decoder[11] = 
			0b01110111,		// segment pattern for the number 0
			0b00100010,		// segment pattern for the number 1
			0b10110101,		// segment pattern for the number 2
			0b10110011,		// segment pattern for the number 3
			0b11100010,		// segment pattern for the number 4
			0b11010011,		// segment pattern for the number 5
			0b11010111,		// segment pattern for the number 6
			0b00110010,		// segment pattern for the number 7
			0b11110111,		// segment pattern for the number 8
			0b11110011,		// segment pattern for the number 9
			0b11011101;		// pattern for the E 


//------- Funkcije koristene u programu --------

void interrupt GlobalInterrupt(void);
//unsigned char KeyRead(void);
char DecodeKey(char keycode);
static void interrupt isr(void);
void setuj(void);
void  displej(unsigned int display_value);
void  komada_displej(unsigned char display_value);
//**********************************************************************
//Main
//**********************************************************************
void main(void)
{
 	
	INT0F = 0;
	TMR0=0;
	INTCON = 0b11100000;
	INTCON2 =0b00000000;
	INTCON3 =0b00000000;
	PIE1 = 0b00000001;			// Enable TMR2 interrupts
	PIE2 = 0b00000010;
	T0CON = 0b10101000; 		
	//T2CON = 0b01001100;         
	
	
	ADCON1 = 0b00000110;			//RA0 analog rest digital
	T1CON=0b00000111;            //ulaz sa rc0
	T3CON=0b00000101;
	TMR3IE=1;
	TMR1IE=1;
	IPEN=0;


	

 //-- Setovanje portova mikrokontrolera --
 TRISA=0b00010000;    
 TRISB=0b00000000;    
 TRISC=0b00001111;    
 TRISD=0b11110011;    
 TRISE=0b00000111;    
   
PORTA=0;
PORTB=0;
PORTC=0;
PORTD=0;
PORTE=0;


TMR3H=0xF8;
TMR3L=0x00;	
display_segment_[1]=segment_decoder[0];
display_segment_[2]=segment_decoder[0];
display_segment_[3]=segment_decoder[0];
display_segment_[4]=segment_decoder[0];
TMR0H=0;
TMR0L=0;
TMR1H=0;
TMR1L=0;
step=0;
brojac=0;
brojac1=0;
brojac2=0;
deshilj=0;
hilj=0;
sto=0;
des=0;
jed=0;
koeficijent=(float)0.345;
Key_real=21;
setup=6;
setup1=0;
set=setup;
L=6;
taster_otpusten=5;
brojac=0;
tmr3_brojac=0;
timer_skare=0;
a_prva_faza=stop;
b_prva_faza=stop;
broj_komada=0;
novi_ciklus=0;
jedan_ciklus=0;
motor=stop;
skare=stop;
stroj_radi=stop;
zadana_duzina=stop;
rina_izradjena=stop;
timer_skare=stop;
izbacivanje_lima=stop;
_dcnt=25000;
 while(--_dcnt != 0) 
 continue; 
 
 
 TMR0H=0;
TMR0L=0;
TMR1H=0;
TMR1L=0;
 
 while(1)
 {
asm("	clrwdt");
	 

data_TMR0L=TMR0L;
data_TMR0H=TMR0H;
brojac1=data_TMR0H<<8;
brojac1=brojac1+data_TMR0L;

data_TMR1L=TMR1L;
data_TMR1H=TMR1H;
brojac2=data_TMR1H<<8;
brojac2=brojac2+data_TMR1L;


if(setup1<1){
brojac=brojac1-brojac2;
izmjerena_duzina=brojac;
//brojac_float=(float)brojac*koeficijent;
//brojac=(float)brojac_float;
komada_displej(broj_komada);
//displej(zadana_duzina);
displej(brojac);
}


if((motor==start) && (sensor_skara_gore==1)){
	if(stroj_radi==start){
		motor=stop;
		}
	}		
		


if(!start_tipka){
		if((sensor_lima==start) && (sensor_skara_gore==0)){
		start_timer++;
		}
		else
		{
			start_timer=0;
		}
		
		if(sensor_preostali_lim==0 ){
		start_timer++;
		}
		else
		{
			start_timer=0;
		}
if(start_timer>400){
	start_timer=0;
	if(broj_komada==0){
		if(zadana_duzina>19){
		jedan_ciklus=start;
		//broj_komada=1;
		}
	}
if(broj_komada>0){
	if(zadana_duzina>19){
novi_ciklus=start;	
//start_stroja=start;
}
}
TMR0H=0;
TMR0L=0;
TMR1H=0;
TMR1L=0;
brojac4=0;
}
}

if(start_tipka){
start_timer=0;
}

if(stop_tipka){
//motor=stop;
//stroj_radi=stop;
brojac=0;
TMR0H=0;
TMR0L=0;
TMR1H=0;
TMR1L=0;
izmjerena_duzina=0;
}
if((novi_ciklus==start) && (sensor_lima==start)){
	if(zadana_duzina > izmjerena_duzina){
		if((sensor_preostali_lim==0 ) && (sensor_skara_gore==0)){
			motor=start;
			stroj_radi=start;			
			novi_ciklus=stop;
			a_prva_faza=start;	
		}	
	}
}


if((jedan_ciklus==start) && (sensor_lima==start)){
	if(zadana_duzina > izmjerena_duzina){
		if((sensor_preostali_lim ==0) && (sensor_skara_gore==0)){
			motor=start;
			stroj_radi=start;
			jedan_ciklus=stop;			
			//start_stroja=stop;
			b_prva_faza=start;
			
		}	
	}
}


if(a_prva_faza==start){
if((zadana_duzina < izmjerena_duzina) && (stroj_radi==start)){
	stroj_radi=stop;
	motor=stop;
	rina_izradjena=start;
	timer_skare=start;
	a_prva_faza=stop;
}
}

if(b_prva_faza==start){
if((zadana_duzina < izmjerena_duzina) && (stroj_radi==start)){
	stroj_radi=stop;
	motor=stop;
	rina_izradjena=start;
	timer_skare=start;
	b_prva_faza=stop;
}
}


if((skare==1)  && (sensor_skara_dolje==0)){
if(rina_izradjena==start){
motor=start;
izbacivanje_lima=start;
rina_izradjena=stop;

}
}

if((izbacivanje_lima==start) && (sensor_lima==start)){
motor=stop;
skare=stop;
rina_izradjena=stop;
broj_komada--;
izbacivanje_lima=stop;

if(broj_komada<0){
	broj_komada=0;
	novi_ciklus=stop;
}

if(broj_komada==0){
novi_ciklus=stop;
broj_komada=0;
}
if(broj_komada>0){
novi_ciklus=start;

}


stroj_radi=stop;
brojac=0;
TMR0H=0;
TMR0L=0;
TMR1H=0;
TMR1L=0;
izmjerena_duzina=0;


}















//******************* deo koji obradjuje tastaturu i sta je ukucano 
if(taster_otpusten>250){
taster_otpusten=5;
}


if(KeyPressed!=0){
Key_real=DecodeKey(KeyPressed);


if(Key_real==100){
		setup1=1;
		setup=0;
		set=setup;
		//set=1;
		L=4;
		}

if(Key_real==101){
	
		setup1=1;
		setup=1;
		set=setup;
		//set=2;
		L=6;	
		}

if(Key_real==102){
	
		setup1=1;
		setup=2;
		set=setup;	
		}

if(Key_real==103){
	
		setup1=1;
		setup=3;
		set=setup;	
		}

if(Key_real==104){
	
		setup1=1;
		setup=4;

		set=setup;	
		}

if(Key_real==105){
	
		setup1=1;
		setup=5;
		set=setup;	
		}
}

if(step==1){
if(taster_pritisnut == 0){

L--;
step=0;

if(setup1==1){
if(setup==0){
if(L<1){
L=4;

setup1=0;

Key_real=21;
}
}
}

if(setup1==1){
if(setup==1){
if(L<5){
L=6;

setup1=0;

Key_real=21;
}
}
}

}
}

	
	


if(setup1==1){

	switch(setup)
					{ 
				
						
						case 0: 	for(X=0;X<5;X++){
												display_segment_[X+1] = segment_decoder[Buffer1[X]];
												}			
									break;	
						
						case 1: 	for(X=0;X<2;X++){
												display_segment_komada[X+1] = segment_decoder[Buffer2[X]];
												}			
									break;				
						
						
						default:	
									break;

	

						}     			// end switch
					
  		
		

if(taster_pritisnut == 1){
							

if(Key_real<10){

		

				switch(setup)
					{ 
				
						
						case 0: //displej(greska1);	
								//display_segment_[L]=segment_decoder[Key_real];
								Buffer1[L-1]=Key_real;
								step=1;
							  								
						   			break;	
						
						case 1: //displej(greska2);			
								//display_segment_komada[L-5]=segment_decoder[Key_real];
								Buffer2[L-5]=Key_real;
								step=1;
							
									
					   				break;				
					

						default:	
									break;

	

						}     			// end switch
						
		setuj();
}
}

}

}

}
//******************* END OF Main

//******************* funkcija za obradu interapta
static void interrupt
	isr(void) {
			


			if(TMR0IF){
	TMR0IF=0;  //TMR0 interrupt
	data_TMR0L=TMR0L;
	data_TMR0H=TMR0H;

	}

	if(TMR1IF){
	TMR1IF=0;  //TMR1 interrupt
	data_TMR1L=TMR1L;
	data_TMR1H=TMR1H;
	
	}
		

	







	if(TMR3IF){//pocinje tmr3
	TMR3IF=0;  //TMR3 interrupt


TMR3H=0xF4;
TMR3L=0x00;
if(setup1==1){// posvetljenje displeja kod setovanja
		if((L==1) && (mux_common==6)){
		TMR3H=0xC0;
		TMR3L=0x00;
		}
		if(mux_common==L-1){
		TMR3H=0xC0;
		TMR3L=0x00;
		}
		
		}// kraj posvetljenja

if(timer_skare){
brojac4++;
}

if(brojac4>1000){
		brojac4=0;
		timer_skare=0;	
		skare=start;
		}	




tmr3_brojac++;

//************rutina za multiplex displeja

mux_common++;			// Move onto to next display
segments = 0;			// Turn off all 7 segments and decimal point
//leds=0;
common_1 = 0;
common_2 = 0;
common_3 = 0;
common_4 = 0;
common_5 = 1;
common_6 = 1;	
	if(mux_common == 7)		// Reset display selection after the third display
		mux_common = 1;
	
	if(mux_common == 1){		// Turn on Common 1 if first display is selected
		segments = display_segment_[1];	// Turn on the segments for display 1
		//leds = channel_led_1;
		common_1 = 1;
		}
	if(mux_common == 2){		// Turn on Common 2 if second display is selected
		segments = display_segment_[2];	// Turn on the segments for display 2
		//leds= channel_led_2;
		common_2 = 1;
		}
	if(mux_common == 3){		// Turn on Common 3 if third display is selected
		segments = display_segment_[3];	// Turn on the segments for display 3
		//leds = channel_led_3;
		common_3 = 1;
		}
	if(mux_common == 4){		// Turn on Common 4 if third display is selected
		segments = display_segment_[4];	// Turn on the segments for display 3
		//leds = channel_led_4;
		common_4 = 1;
		}
	if(mux_common == 5){		// Turn on Common 5 if third display is selected
		segments = display_segment_komada[1];	// Turn on the segments for display 3
		//leds = channel_led_5;
		common_5 = 0;
		}	

	if(mux_common == 6){		// Turn on Common 5 if third display is selected
		segments = display_segment_komada[2];	// Turn on the segments for display 3
		//leds = channel_led_6;
		common_6 = 0;
		}
//************kraj rutine za multiplex displeja

//***********pocetak obrade tastature

		if(PORTD>15){
			taster_pritisnut=1;
			taster_otpusten=0;
	
			
		if(tmr3_brojac>20){    //obrada tastature
			tmr3_brojac=0;
		
			
			nova_vrednost=PORTD & 0b11110000;
					if(stara_vrednost != nova_vrednost){
						stara_vrednost=nova_vrednost;
						KeyPressed=0;
						
						}
					if(stara_vrednost == nova_vrednost){
						
						
						temp2=PORTC >>4;
						KeyPressed=nova_vrednost | temp2;
						
						}

					}
				}



			if(PORTD<15)
	
			{
			taster_otpusten++;
			if(taster_otpusten<5){
			taster_pritisnut=1;
			}
			else{
			taster_pritisnut=0;
			stara_vrednost =0;
			nova_vrednost=0;
			KeyPressed=0;
			}	
			}
//***********kraj obrade tastature

}//zavrsava tmr3



	
	
	

		
	
	
	


}
//******************* kraj funkcije za obradu interapta



//**********************************************************************
//funkcija za dekodiranje sta je pritisnuto na tastaturi
//**********************************************************************
char DecodeKey(char keycode)
{
 switch(keycode)
 {
  
  case 136:
   return(0);
  case 132:
   return(2);
  case 130:
   return(5);
  case 129:
   return(8);

  case 40:
   return(100);
  case 68:
   return(3);
  case 66:
   return(6);
  case 65:
   return(9);

  

  case 72:
   return(101);
  case 36:
   return(1);
  case 34:
   return(4);
  case 33:
   return(7);
  
  default:
   break;
 }
 return(21);
}
//*******************kraj funkcije za dekodiranje sta je pritisnuto na tastaturi 

void  displej(unsigned int display_value){
unsigned char	temp;

	if(display_value<0){
	display_segment_[4] = segment_decoder[10];
	display_segment_[3] = segment_decoder[10];
	display_segment_[2] = segment_decoder[10];
	display_segment_[1] = segment_decoder[10];
	}
	else{
	
	temp = 0;
	while (display_value >999){
			temp++;
			display_value -= 1000;
			}
		display_segment_[4] = segment_decoder[temp];


	temp = 0;
	while (display_value >99){
			temp++;
			display_value -= 100;
			}
		display_segment_[3] = segment_decoder[temp];


	temp = 0;
	while (display_value > 9){
			temp++;
			display_value -= 10;
			}
	display_segment_[2] = segment_decoder[temp];


	display_segment_[1] = segment_decoder[(unsigned char)display_value];
	
	}
		
	}






void  komada_displej(unsigned char display_value){
unsigned char	temp;

	temp = 0;
	while (display_value > 9){
			temp++;
			display_value -= 10;
			}
	display_segment_komada[2] = segment_decoder[temp];


	display_segment_komada[1] = segment_decoder[(unsigned char)display_value];
	
	
		
	}












//*******************funkcija za setovanje(pretvaranje polja u karaktere)
void setuj(void)
{

//hilj=0;
//sto=0;
//des=0;
//jed=0;
hilj=Buffer1[3];
sto=Buffer1[2];
des=Buffer1[1];
jed=Buffer1[0];	
zadana_duzina=hilj*1000+sto*100+des*10+jed;

//hilj=(Buffer2[0])*1000;
//sto=(Buffer2[1])*100;
des_kom=Buffer2[1];
jed_kom=Buffer2[0];	
broj_komada=des_kom*10+jed_kom;
//des_hilj=(Buffer1[0])*10000;
//hilj=(Buffer1[1])*1000;
//sto=(Buffer1[2])*100;
//des=(Buffer1[3])*10;
//jed=(Buffer1[4]);	
//navoja=des_hilj+hilj+sto+des+jed;


}
//*******************kraj funkcije za setovanje(pretvaranje polja u karaktere)








//******************* kraj 


